PLaSK library

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
plask::aligned_allocator< T > Struct Template Reference

STL compatible allocator to use with with 16 byte aligned types. More...

`#include <plask/memalloc.hpp>`

## Classes
struct | rebind

## Public Types
typedef std::size_t | size_type
typedef std::ptrdiff_t | difference_type
typedef T * | pointer
typedef const T * | const_pointer
typedef T & | reference
typedef const T & | const_reference
typedef T | value_type

## Public Member Functions
pointer | address (reference value) const
const_pointer | address (const_reference value) const
| aligned_allocator ()
| aligned_allocator (const aligned_allocator &)
template<class U >
| aligned_allocator (const aligned_allocator< U > &)
| ~aligned_allocator ()
size_type | max_size () const
pointer | allocate (size_type num)
void | construct (pointer p, const T &value)
template<typename... Args>
void | construct (pointer p, Args &&... args)
void | destroy (pointer p)
void | deallocate (pointer p, size_type)
bool | operator!= (const aligned_allocator< T > &) const
bool | operator== (const aligned_allocator< T > &) const

## Detailed Description

template<class T>
struct plask::aligned_allocator< T >

STL compatible allocator to use with with 16 byte aligned types.

Definition at line 234 of file memalloc.hpp.

## Member Typedef Documentation

## ◆ const_pointer

template<class T >

typedef const T* plask::aligned_allocator< T >::const_pointer

Definition at line 239 of file memalloc.hpp.

## ◆ const_reference

template<class T >

typedef const T& plask::aligned_allocator< T >::const_reference

Definition at line 241 of file memalloc.hpp.

## ◆ difference_type

template<class T >

typedef std::ptrdiff_t plask::aligned_allocator< T >::difference_type

Definition at line 237 of file memalloc.hpp.

## ◆ pointer

template<class T >

typedef T* plask::aligned_allocator< T >::pointer

Definition at line 238 of file memalloc.hpp.

## ◆ reference

template<class T >

typedef T& plask::aligned_allocator< T >::reference

Definition at line 240 of file memalloc.hpp.

## ◆ size_type

template<class T >

typedef std::size_t plask::aligned_allocator< T >::size_type

Definition at line 236 of file memalloc.hpp.

## ◆ value_type

template<class T >

typedef T plask::aligned_allocator< T >::value_type

Definition at line 242 of file memalloc.hpp.

## Constructor & Destructor Documentation

## ◆ aligned_allocator() [1/3]

template<class T >

plask::aligned_allocator< T >::aligned_allocator | ( |  | ) |
| inline

Definition at line 251 of file memalloc.hpp.

## ◆ aligned_allocator() [2/3]

template<class T >

plask::aligned_allocator< T >::aligned_allocator | ( | const aligned_allocator< T > & |  | ) |
| inline

Definition at line 253 of file memalloc.hpp.

## ◆ aligned_allocator() [3/3]

template<class T >
template<class U >

plask::aligned_allocator< T >::aligned_allocator | ( | const aligned_allocator< U > & |  | ) |
| inline

Definition at line 256 of file memalloc.hpp.

## ◆ ~aligned_allocator()

template<class T >

plask::aligned_allocator< T >::~aligned_allocator | ( |  | ) |
| inline

Definition at line 258 of file memalloc.hpp.

## Member Function Documentation

## ◆ address() [1/2]

template<class T >

const_pointer plask::aligned_allocator< T >::address | ( | const_reference | value | ) | const
| inline

Definition at line 249 of file memalloc.hpp.

## ◆ address() [2/2]

template<class T >

pointer plask::aligned_allocator< T >::address | ( | reference | value | ) | const
| inline

Definition at line 247 of file memalloc.hpp.

## ◆ allocate()

template<class T >

pointer plask::aligned_allocator< T >::allocate | ( | size_type | num | ) |
| inline

Definition at line 262 of file memalloc.hpp.

## ◆ construct() [1/2]

template<class T >
template<typename... Args>

void plask::aligned_allocator< T >::construct | ( | pointer | p,
|  | Args &&... | args
| ) |  |
| inline

Definition at line 267 of file memalloc.hpp.

## ◆ construct() [2/2]

template<class T >

void plask::aligned_allocator< T >::construct | ( | pointer | p,
|  | const T & | value
| ) |  |
| inline

Definition at line 264 of file memalloc.hpp.

## ◆ deallocate()

template<class T >

void plask::aligned_allocator< T >::deallocate | ( | pointer | p,
|  | size_type |
| ) |  |
| inline

Definition at line 271 of file memalloc.hpp.

## ◆ destroy()

template<class T >

void plask::aligned_allocator< T >::destroy | ( | pointer | p | ) |
| inline

Definition at line 269 of file memalloc.hpp.

## ◆ max_size()

template<class T >

size_type plask::aligned_allocator< T >::max_size | ( |  | ) | const
| inline

Definition at line 260 of file memalloc.hpp.

## ◆ operator!=()

template<class T >

bool plask::aligned_allocator< T >::operator!= | ( | const aligned_allocator< T > & |  | ) | const
| inline

Definition at line 273 of file memalloc.hpp.

## ◆ operator==()

template<class T >

bool plask::aligned_allocator< T >::operator== | ( | const aligned_allocator< T > & |  | ) | const
| inline

Definition at line 275 of file memalloc.hpp.

The documentation for this struct was generated from the following file:

- plask/memalloc.hpp